package org.hardknockjava.lesson20.example01.reader.broadway;

import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

import org.apache.commons.lang3.StringUtils;

public class ShowPOJO {
    private static final String EMPTY = "(empty)";
    private static final String NULL = "(null)";

    public static final String FIELD_TITLE = "title";
    public static final String FIELD_THEATRE = "theatre";
    public static final String FIELD_PLAYWRIGHTS = "playwrights";
    public static final String FIELD_PLAYWRIGHT = "playwright";
    public static final String FIELD_COMPOSERS = "composers";
    public static final String FIELD_COMPOSER = "composer";
    public static final String FIELD_LYRICISTS = "lyricists";
    public static final String FIELD_LYRICIST = "lyricist";
    public static final String FIELD_OPENING = "opening";
    public static final String FIELD_CLOSING = "closing";
    public static final String FIELD_PREVIEWS = "previews";
    public static final String FIELD_PERFORMANCES = "performances";

    private String title;
    private String theatre;
    private List<String> playwrightList = new ArrayList<String>();
    private List<String> composerList = new ArrayList<String>();
    private List<String> lyricistList = new ArrayList<String>();
    private Date opening;
    private Date closing;
    private Integer previews;
    private Integer performances;

    public ShowPOJO(String title, String theatre, List<String> playwrightList, List<String> composerList,
            List<String> lyricistList, Date opening, Date closing, Integer previews, Integer performances) {
        super();
        this.title = title;
        this.theatre = theatre;
        this.playwrightList = playwrightList;
        this.composerList = composerList;
        this.lyricistList = lyricistList;
        this.opening = opening;
        this.closing = closing;
        this.previews = previews;
        this.performances = performances;
    }

    public String getTitle() {
        return title;
    }

    public String getTheatre() {
        return theatre;
    }

    public List<String> getPlaywrightList() {
        return playwrightList;
    }

    public List<String> getComposerList() {
        return composerList;
    }

    public List<String> getLyricistList() {
        return lyricistList;
    }

    public Date getOpening() {
        return opening;
    }

    public Date getClosing() {
        return closing;
    }

    public Integer getPreviews() {
        return previews;
    }

    public void setPreviews(Integer previews) {
        this.previews = previews;
    }

    public Integer getPerformances() {
        return performances;
    }

    public void setPerformances(Integer performances) {
        this.performances = performances;
    }

    public String toString() {
        String openingStr = null;
        String closingStr = null;
        String previewsStr = null;
        String performancesStr = null;

        SimpleDateFormat fmt = new SimpleDateFormat("MM/dd/yyyy");

        if (opening != null) {
            openingStr = fmt.format(opening);
        }
        if (closing != null) {
            closingStr = fmt.format(closing);
        }
        if (previews != null) {
            previewsStr = previews.toString();
        }
        if (performances != null) {
            performancesStr = performances.toString();
        }
        return "Title: " + evaluate(title) + " " //
                + "Playwright: " + evaluate(playwrightList) + " " //
                + "Theatre: " + evaluate(theatre) + " " //
                + "Composer: " + evaluate(composerList) + " " //
                + "Lyricist: " + evaluate(lyricistList) + " " //
                + "Opening: " + evaluate(openingStr) + " " //
                + "Closing: " + evaluate(closingStr)  + " " //
                + "Previews: " + evaluate(previewsStr)  + " " //
                + "Performances: " + evaluate(performancesStr);

    }

    private String evaluate(List<String> value) {
        return StringUtils.join(value, ',');
    }
    
    private String evaluate(String value) {
        if (value == null) {
            return NULL;
        }
        if (value.isEmpty()) {
            return EMPTY;
        } else {
            return value;
        }
    }
}
